Bug 770795 - blkioParameters doesn't work
Summary: blkioParameters doesn't work
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: libvirt
Version: 6.3
Hardware: x86_64
OS: Linux
medium
medium
Target Milestone: rc
: ---
Assignee: Osier Yang
QA Contact: Virtualization Bugs
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-12-29 06:42 UTC by Alex Jia
Modified: 2013-02-21 07:06 UTC (History)
6 users (show)

Fixed In Version: libvirt-0.9.13-3.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-02-21 07:06:58 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2013:0276 0 normal SHIPPED_LIVE Moderate: libvirt security, bug fix, and enhancement update 2013-02-20 21:18:26 UTC

Description Alex Jia 2011-12-29 06:42:39 UTC
Description of problem:
virsh blkiotune works well, and can get current blkio parameters for a guest,
but blkioParameters python binding API doesn't work and return None. 

In addition, blkioParameters hasn't judged return value from libvirt.py.

# virsh blkiotune foo
weight         : 200
device_weight  : 


Version-Release number of selected component (if applicable):
libvirt-python-0.9.8-1.el6.x86_64

How reproducible:
always

Steps to Reproduce:
# python
Python 2.6.6 (r266:84292, Sep 12 2011, 14:03:14) 
[GCC 4.4.5 20110214 (Red Hat 4.4.5-6)] on linux2
Type "help", "copyright", "credits" or "license" for more information.
>>> import libvirt
>>> con = libvirt.open(None)
>>> dom = con.lookupByName('foo')
>>> print dom.blkioParameters(0)
None


Expected results:
blkioParameters works well like virsh blkiotune.

Additional info:
Will try to commit a patch for the bug.

Comment 1 Alex Jia 2011-12-29 11:13:37 UTC
Patch for upstream:
https://www.redhat.com/archives/libvir-list/2011-December/msg01094.html

Comment 2 Alex Jia 2011-12-29 11:15:01 UTC
And the above patch also fix issue of the setBlkioParameters python binding API.

Comment 3 Alex Jia 2012-01-17 03:30:41 UTC
v2 patch for upstream:
https://www.redhat.com/archives/libvir-list/2011-December/msg01122.html

Comment 4 Alex Jia 2012-02-06 08:29:33 UTC
The patch need to be updated according to latest libvirt change, for example, reusing utility library function in python binding codes, in addition, also need to wait for codes re-factoring about python binding part.

Comment 5 Alex Jia 2012-02-10 09:40:49 UTC
The v3 patch has been sent to upstream and wait for review:
https://www.redhat.com/archives/libvir-list/2012-February/msg00525.html

Comment 6 Alex Jia 2012-02-16 16:51:11 UTC
The following patch has fixed the issue instead, In POST:
 commit 56cec18d761a1f99862c43811de60380c65881e6
Author: Guannan Ren <gren@redhat.com>
Date:   Fri Feb 10 18:17:26 2012 +0800

    python: make other APIs share common {get, set}PyVirTypedParameter
    
            *libvirt_virDomainBlockStatsFlags
            *libvirt_virDomainGetSchedulerParameters
            *libvirt_virDomainGetSchedulerParametersFlags
            *libvirt_virDomainSetSchedulerParameters
            *libvirt_virDomainSetSchedulerParametersFlags
            *libvirt_virDomainSetBlkioParameters
            *libvirt_virDomainGetBlkioParameters
            *libvirt_virDomainSetMemoryParameters
            *libvirt_virDomainGetMemoryParameters
            *libvirt_virDomainSetBlockIoTune
            *libvirt_virDomainGetBlockIoTune

Comment 9 Wayne Sun 2012-07-24 10:39:35 UTC
pkgs:
libvirt-0.9.13-3.el6.x86_64
qemu-kvm-rhev-0.12.1.2-2.297.el6_3.x86_64
kernel-2.6.32-280.el6.x86_64

steps:

# virsh blkiotune aaa
weight         : 500
device_weight  : 

In another terminal:
# python
Python 2.6.6 (r266:84292, May  1 2012, 13:52:17) 
[GCC 4.4.6 20110731 (Red Hat 4.4.6-3)] on linux2
Type "help", "copyright", "credits" or "license" for more information.
>>> import libvirt
>>> conn = libvirt.open(None)
>>> domobj = conn.lookupByName("aaa")
>>> domobj.blkioParameters(0)
{'device_weight': '', 'weight': 500}

switch back and run:
# virsh blkiotune aaa 1000

switch to python:
>>> domobj.blkioParameters(0)
{'device_weight': '', 'weight': 1000}

So, it's fine now.

Comment 10 errata-xmlrpc 2013-02-21 07:06:58 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2013-0276.html


Note You need to log in before you can comment on or make changes to this bug.